#ifndef LEAFNODE_H
#define LEAFNODE_H

#include <cstdio>
#include <cctype>

#include "node.h"

class LeafNode : public Node
{
public:
	LeafNode(char symbol, unsigned value) : m_symbol(symbol), m_value(value)
	{
	}

	virtual unsigned getValue(void) const override
	{
		return m_value;
	}

	virtual void print(unsigned level) const override
	{
		for (unsigned i = 0; i < level; i++)
			printf("    ");
		uint8_t code = m_symbol;
		char c = isprint(code) ? code : '.';
		printf("[v = %i, s = '%c' (0x%.2x)]\n", getValue(), c, code);
	}

	virtual void addCode(std::map<char, std::string> &dict, std::string code) const override
	{
		dict[m_symbol] = code;
	}

private:
	char m_symbol;
	unsigned m_value;
};

#endif
